﻿var gyAPI = require("gy-api")();

window.playChatAudio = function (el, url) {
	var id = "playChatAudio";
	var audio = document.getElementById(id);
	if (audio) {
		audio.src = url;
	} else {
		audio = new Audio();
		audio.controls = false;  //这样控件才能显示出来
		audio.src = url;  //音乐的路径
		audio.autoplay = "autoplay";
		audio.id = id;
		document.body.appendChild(audio);  //把它添加到页面中
	}
	audio.play();
	var playIconObj = el.childNodes[0];
	playIconObj.className = "chatYuyinPlay";
	var playEnd = setInterval(function () {
		console.log(audio.ended);
		if (audio.ended) {
			clearInterval(playEnd);
			playIconObj.className = "chatYuyinPause";
		}
	}, 10);
};

//var uuid=require('node-uuid');
function Chat(struct) {
	this.data = {};
	this.nim = {};//聊天云信组件
	this.struct = struct || {};//初始化结构信息
	this.userMap = {};//缓存用户的map信息，
	this.timeSplit = this.struct.timeSplit || 5;//用来记录日期时间分隔的间距，以分钟为单位
	this.errorMap = this.struct.errorMap || { "600": "网络不佳,正在尝试重建连接！", "417": "您已在其它客户端登录", "302": "账号或者密码错误", "700": "您已被移出当前群", "kicked": "授权失败", "1201": "您已被禁言，不能进行聊天操作" };
	this.preTime = 0;
	this.path = "/statics/chat/";
	this.emoji = { "[大笑]": { file: "emoji_0.png" }, "[可爱]": { file: "emoji_01.png" }, "[色]": { file: "emoji_02.png" }, "[嘘]": { file: "emoji_03.png" }, "[亲]": { file: "emoji_04.png" }, "[呆]": { file: "emoji_05.png" }, "[口水]": { file: "emoji_06.png" }, "[汗]": { file: "emoji_145.png" }, "[呲牙]": { file: "emoji_07.png" }, "[鬼脸]": { file: "emoji_08.png" }, "[害羞]": { file: "emoji_09.png" }, "[偷笑]": { file: "emoji_10.png" }, "[调皮]": { file: "emoji_11.png" }, "[可怜]": { file: "emoji_12.png" }, "[敲]": { file: "emoji_13.png" }, "[惊讶]": { file: "emoji_14.png" }, "[流感]": { file: "emoji_15.png" }, "[委屈]": { file: "emoji_16.png" }, "[流泪]": { file: "emoji_17.png" }, "[嚎哭]": { file: "emoji_18.png" }, "[惊恐]": { file: "emoji_19.png" }, "[怒]": { file: "emoji_20.png" }, "[酷]": { file: "emoji_21.png" }, "[不说]": { file: "emoji_22.png" }, "[鄙视]": { file: "emoji_23.png" }, "[阿弥陀佛]": { file: "emoji_24.png" }, "[奸笑]": { file: "emoji_25.png" }, "[睡着]": { file: "emoji_26.png" }, "[口罩]": { file: "emoji_27.png" }, "[努力]": { file: "emoji_28.png" }, "[抠鼻孔]": { file: "emoji_29.png" }, "[疑问]": { file: "emoji_30.png" }, "[怒骂]": { file: "emoji_31.png" }, "[晕]": { file: "emoji_32.png" }, "[呕吐]": { file: "emoji_33.png" }, "[拜一拜]": { file: "emoji_160.png" }, "[惊喜]": { file: "emoji_161.png" }, "[流汗]": { file: "emoji_162.png" }, "[卖萌]": { file: "emoji_163.png" }, "[默契眨眼]": { file: "emoji_164.png" }, "[烧香拜佛]": { file: "emoji_165.png" }, "[晚安]": { file: "emoji_166.png" }, "[强]": { file: "emoji_34.png" }, "[弱]": { file: "emoji_35.png" }, "[OK]": { file: "emoji_36.png" }, "[拳头]": { file: "emoji_37.png" }, "[胜利]": { file: "emoji_38.png" }, "[鼓掌]": { file: "emoji_39.png" }, "[握手]": { file: "emoji_200.png" }, "[发怒]": { file: "emoji_40.png" }, "[骷髅]": { file: "emoji_41.png" }, "[便便]": { file: "emoji_42.png" }, "[火]": { file: "emoji_43.png" }, "[溜]": { file: "emoji_44.png" }, "[爱心]": { file: "emoji_45.png" }, "[心碎]": { file: "emoji_46.png" }, "[钟情]": { file: "emoji_47.png" }, "[唇]": { file: "emoji_48.png" }, "[戒指]": { file: "emoji_49.png" }, "[钻石]": { file: "emoji_50.png" }, "[太阳]": { file: "emoji_51.png" }, "[有时晴]": { file: "emoji_52.png" }, "[多云]": { file: "emoji_53.png" }, "[雷]": { file: "emoji_54.png" }, "[雨]": { file: "emoji_55.png" }, "[雪花]": { file: "emoji_56.png" }, "[爱人]": { file: "emoji_57.png" }, "[帽子]": { file: "emoji_58.png" }, "[皇冠]": { file: "emoji_59.png" }, "[篮球]": { file: "emoji_60.png" }, "[足球]": { file: "emoji_61.png" }, "[垒球]": { file: "emoji_62.png" }, "[网球]": { file: "emoji_63.png" }, "[台球]": { file: "emoji_64.png" }, "[咖啡]": { file: "emoji_65.png" }, "[啤酒]": { file: "emoji_66.png" }, "[干杯]": { file: "emoji_67.png" }, "[柠檬汁]": { file: "emoji_68.png" }, "[餐具]": { file: "emoji_69.png" }, "[汉堡]": { file: "emoji_70.png" }, "[鸡腿]": { file: "emoji_71.png" }, "[面条]": { file: "emoji_72.png" }, "[冰淇淋]": { file: "emoji_73.png" }, "[沙冰]": { file: "emoji_74.png" }, "[生日蛋糕]": { file: "emoji_75.png" }, "[蛋糕]": { file: "emoji_76.png" }, "[糖果]": { file: "emoji_77.png" }, "[葡萄]": { file: "emoji_78.png" }, "[西瓜]": { file: "emoji_79.png" }, "[光碟]": { file: "emoji_80.png" }, "[手机]": { file: "emoji_81.png" }, "[电话]": { file: "emoji_82.png" }, "[电视]": { file: "emoji_83.png" }, "[声音开启]": { file: "emoji_84.png" }, "[声音关闭]": { file: "emoji_85.png" }, "[铃铛]": { file: "emoji_86.png" }, "[锁头]": { file: "emoji_87.png" }, "[放大镜]": { file: "emoji_88.png" }, "[灯泡]": { file: "emoji_89.png" }, "[锤头]": { file: "emoji_90.png" }, "[烟]": { file: "emoji_91.png" }, "[炸弹]": { file: "emoji_92.png" }, "[枪]": { file: "emoji_93.png" }, "[刀]": { file: "emoji_94.png" }, "[药]": { file: "emoji_95.png" }, "[打针]": { file: "emoji_96.png" }, "[钱袋]": { file: "emoji_97.png" }, "[钞票]": { file: "emoji_98.png" }, "[银行卡]": { file: "emoji_99.png" }, "[手柄]": { file: "emoji_100.png" }, "[麻将]": { file: "emoji_101.png" }, "[调色板]": { file: "emoji_102.png" }, "[电影]": { file: "emoji_103.png" }, "[麦克风]": { file: "emoji_104.png" }, "[耳机]": { file: "emoji_105.png" }, "[音乐]": { file: "emoji_106.png" }, "[吉他]": { file: "emoji_107.png" }, "[火箭]": { file: "emoji_108.png" }, "[飞机]": { file: "emoji_109.png" }, "[火车]": { file: "emoji_110.png" }, "[公交]": { file: "emoji_111.png" }, "[轿车]": { file: "emoji_112.png" }, "[出租车]": { file: "emoji_113.png" }, "[警车]": { file: "emoji_114.png" }, "[自行车]": { file: "emoji_115.png" } };
	this.linkStatus = 100;//100初始化,200连接成功，600断开重连,400连接未建立，500网络断开，302账号或者密码错误，417重复登录, 已经在其它端登录了，kicked被踢, 请提示错误后跳转到登录页面
	this.FailMsgs = {};
	this.imgList = [];
	this.init();
	this.startTime = (new Date()).getTime();
}
Chat.prototype = {
	/**
	*初始化信息，用于初始化聊天所需基本数据
	**/
	init: function () {
		var that = this;

		if (!(that.struct.appKey && that.struct.account && that.struct.token)) {
			console.error('init is error');
		}
		var userMapStr = localStorage.getItem(that.struct.groupId);
		if (userMapStr) {
			that.userMap = JSON.parse(userMapStr);
		}
	},
	setLinkStatus: function (v) {
		var that = this;
		if (v === "kicked" || v === 100 || (v > 300)) {
			//通知客户端错误
			if (that.struct.linkErrorFun) {
				that.struct.linkErrorFun(v);
			}
		}
		that.linkStatus = v;
	},
	getImgList: function () {
		return this.imgList;
	},
	/**
	*显示聊天信息
	**/
	show: function () {
		var own = this;
		var methods = {
			onConnect: function () {
				console.log('连接成功');
				own.setLinkStatus(200);
			},
			onSyncDone: function () {
				if (own.struct.syncDoneEnd) {
					own.struct.syncDoneEnd();
				}
				console.log('同步完成');
			},
			/**
			*断开连接后重新连接
			**/
			onWillReconnect: function (obj) {
				// 此时说明 SDK 已经断开连接, 请开发者在界面上提示用户连接已断开, 而且正在重新建立连接
				console.log('即将重连');
				console.log(obj.retryCount);
				console.log(obj.duration);
				//暂不处理600错误。因为微信跳转新页面后还会返回当前页面会一直提示重连
				//own.setLinkStatus(600);
			},
			/**断开连接**/
			onDisconnect: function (error) {
				// 此时说明 SDK 处于断开状态, 开发者此时应该根据错误码提示相应的错误信息, 并且跳转到登录页面
				console.log('丢失连接');
				console.log(error);
				if (error) {
					own.setLinkStatus(error.code);//记录错误编码;
				}
			},
			onUsers: function (user) {
				own.data.user = user;
			},
			onFriends: function (friends) {
				console.log('收到好友列表', friends);
				own.data.friends = own.nim.mergeFriends(own.data.friends, friends);
				own.data.friends = own.nim.cutFriends(own.data.friends, friends.invalid);
			},

			/**
			*初始化会话信息
			**/
			onSessions: function (sessions) {
				var that = this;
				var ownSessions = [];
				if (sessions && sessions.length) {
					for (var i = 0; i < sessions.length; i++) {
						var session = sessions[i];
						if ((session["to"] == own.struct.account) || (session["to"] == own.struct.groupId)) {
							ownSessions.push(session);
							if (own.struct.isSyncRoamingMsgs) {
								own.nim.getLocalMsgs({
									sessionId: session["id"],
									limit: 50,
									done: function (error, obj) {
										console.log("获取本地消息---");
										if (!error && obj && obj.msgs && obj.msgs.length) {
											methods.pushMsg(obj.msgs.reverse());
										}
									}
								});
							}
						}
					}
				}
				//console.log('收到会话列表', sessions);
				own.data.sessions = own.nim.mergeSessions(own.data.sessions, ownSessions);
			},
			/**
			*会话更新方法
			**/
			onUpdateSession: function (session) {
				var that = this;
				console.log('会话更新了', session);
				own.data.sessions = own.nim.mergeSessions(own.data.sessions, session);
				//updateSessionsUI();

			},

			/**
			*收到漫游消息（即我在不同平台上发送的消息）
			**/
			onRoamingMsgs: function (obj) {
				var that = this;
				console.log('收到漫游消息', obj);
				if (obj.to == own.struct.groupId && obj.scene == "team") {
					//obj.msgs=obj.msgs.sort(function(obj1,obj2){obj1.time-obj2.time});
					methods.pushMsg(obj.msgs);
				}
			},
			/**
			*收到离线消息（离线时发送的消息）
			**/
			onOfflineMsgs: function (obj) {
				var that = this;
				console.log('收到离线消息', obj);
				methods.pushMsg(obj.msgs);
			},
			/**
			*收到消息
			**/
			onMsg: function (msg) {
				var that = this;
				methods.pushMsg(msg, null, true);

			},
			/**
			*接收自定义消息
			**/
			onCustomsysmsg: function (msg) {

				//禁止聊天处理(禁言操作)
				if (msg && msg["type"] == "custom") {
					var obj = JSON.parse(msg.content);
					if (obj.type == 1201 || obj.type == 1202) {
						var map = { 1201: true, 1202: false };
						if (own.struct.account == msg.to) {
							own.struct.userGag(map[obj.type]);
							if (obj.type == 1201) {
								own.setLinkStatus(obj.type);
							}
						}
						return;
					}
				}
				methods.pushMsg(msg);
			},
			/**
			*消息统一处理
			**/
			pushMsg: function (msgs, key, isNewMsg) {
				var that = this;
				var msgs_ = [];
				if (Array.isArray(msgs)) {
					for (var i = 0; i < msgs.length; i++) {
						var msg = msgs[i];
						if (msg.to == own.struct.groupId && msg.scene == "team") {
							msgs_.push(msg);
						}
					}
				} else {
					if (msgs.to == own.struct.groupId && msgs.scene == "team") {
						msgs_.push(msgs);
					}
				}
				if (msgs_.length > 0) {
					var sessionId = msgs_[0].sessionId;
					own.data.msgs = own.data.msgs || {};
					own.data.msgs[sessionId] = own.nim.mergeMsgs(own.data.msgs[sessionId], msgs_);
					methods.drewMsgs(msgs_, key, isNewMsg);
					msgs_ = undefined;
				}
			},
			/**
			*自定义消息的处理
			**/
			onCustomMsg: function (msg) {

				// 处理自定义消息
			},
			/**
			*发送消息
			**/
			sendMsg: function (sendMsgText, successFun, errorFun) {
				var that = this;
				var msgKey = (new Date).getTime() + '-' + Math.round(Math.random() * 999 + 1);
				var sendFun = function () {
					var sendMsg = own.nim.sendText({
						scene: 'team',
						to: own.struct.groupId,
						text: sendMsgText,
						done: function (error, msg) {
							console.log("key:" + msgKey);

							if ((!error) && successFun) {
								var jqObj = gyAPI.getObjById(msgKey);
								if (jqObj) {
									jqObj.replaceAllClass("");
								}
								successFun(msg);
							} else if (error && errorFun) {
								var jqObj = gyAPI.getObjById(msgKey);
								own.FailMsgs[msgKey] = msg;
								if (jqObj) {
									jqObj.replaceAllClass("sendFailIcon");
									if (/Error_Connection_is_not_Established/g.test(error.code)) {//网络未建立
										own.setLinkStatus(400);
									}
									if (/Error_Internet_Disconnected/g.test(error.code)) {//断网错误
										own.setLinkStatus(500);
									}
								}
								errorFun(error);
							}
						}
					});
					return sendMsg;
				};
				var msg = sendFun();
				methods.pushMsg(msg, msgKey, true);
				//先关闭发送窗口;
				if (successFun) {
					successFun(msg);
				}
			},
			/**
			*重新发送
			**/
			reSendMsg: function (sendMsgText, msgKey) {
				var status = own.linkStatus;
				if (status == 200) {//连接正常下可以重发。
					var that = this;
					var jqObj = gyAPI.getObjById(msgKey);
					var rendMsg = own.FailMsgs[msgKey];
					var sendFun = function () {
						var sendMsg = own.nim.resendMsg({
							msg: rendMsg,
							done: function (error, msg) {
								jqObj.attr("sending", "");
								if ((!error)) {
									if (jqObj) {
										jqObj.replaceAllClass("");
									}
								} else if (error) {
									own.FailMsgs[msgKey] = msg;
									if (jqObj) {
										jqObj.replaceAllClass("sendFailIcon");
										if (/Error_Connection_is_not_Established/g.test(error.code)) {//网络未建立
											own.setLinkStatus(400);
										}
										if (/Error_Internet_Disconnected/g.test(error.code)) {//断网错误
											own.setLinkStatus(500);
										}
									}
								}
							}
						});
						own.FailMsgs[msgKey] = undefined;
						return sendMsg;
					};
					if (rendMsg && jqObj) {
						jqObj.replaceAllClass("sendingIcon");
						jqObj.attr("sending", true);
					}
					var msg = sendFun();
				} else {
					var msg_ = own.errorMap[status];
					if (msg_) {
						msg_ = msg_ + "请稍后重试";
					} else {
						msg_ = "网络异常，请刷新后重试";
					}
					own.struct.alertNotice(msg_);
				}
			},
			/**
			*绘制消息
			**/
			drewMsgs: function (msgs, key, isNewMsg) {
				var that = this;
				if (Array.isArray(msgs) && msgs.length) {
					for (var i = 0; i < msgs.length; i++) {
						methods.drewMsg(msgs[i], key, isNewMsg);
					}
				} else {
					methods.drewMsg(msg, key, isNewMsg);
				}

			},
			checkHeadImg: function (pathImg, defaultImg) {
				var ImgObj = new Image();
				ImgObj.src = pathImg;
				if (ImgObj.fileSize > 0 || (ImgObj.width > 0 && ImgObj.height > 0)) {
					return pathImg;
				} else {
					return defaultImg;
				}
			},
			/**
			*绘制单条消息
			**/
			drewMsg: function (msg_, key, isNewMsg, callFunMsg) {
				console.log("time:" + msg_["time"] + ",userUpdateTime:" + msg_["userUpdateTime"] + ",text:" + msg_["text"]);
				//如果是漫游消息并且是发送失败的消息。不进行绘制；
				if ((!key) && msg_.status == "fail") {
					return;
				}
				var that = this;
				var msg = msg_.lastMsg || msg_;
				var target = msg["target"];
				var defaultIconMap = { "1": "1.png", "3": "3.png", "11": "11.png", "14": "14.png", "16": "16.png", "17": "17.png", "15": "15.png", "19": "19.png", "31": "31.png", "default": "default.png" };
				var customTypeMap = {
					"6": "禁言", "22": "取消禁言", "1": "论坛", "3": "活动", "11": "名片", "14": "能量卡", "15": "社群",
					"16": "资讯", "17": "企业", "19": "项目", "20": "二维码", "21": "链接", "23": "商务微视", "24": "Boss圈", "25": "节目视频",
					"26": "节目音频", "27": "社群直播", "28": "打赏", "29": "商品", "12": "新人加入", "31": "资讯专题", "33": "会员", "35": "分销"
				};
				//客户消息
				var customType = function (content_) {
					var data = content_["data"] || {};
					if (typeof (data) === "string") {
						data = JSON.parse(data);
					}
					var groupLink=function(linkStr,className){
						className=className?' class="'+className+'"':'';
						if (!gyAPI.isMobile()) {
							return '<a '+className+' href=javascript:window.open("' + linkStr + '","","width=375,height=667")>';
						}
						return '<a href="' + linkStr + '">';
					}
					var typeFunObj = {
						//卡片信息
						"1": function () {
							//活动由于两种类型发送的消息链接不一至，当前前端先做不支持处理。
							if (data["type"] == 3 || (!gyAPI.isMobile())) {
								var text = nonsupport();
								return modelObj(own, msg, text, 'basic');
							}

							var desc = (data && data["desc"]) ? data["desc"].replace(/\r/g, "<br/>") : "";
							var html = '<article class="cont">' + groupLink(data["link"])
								+ '<h1 class="chatBoxType-genre">' + customTypeMap[data["type"]] + '</h1>'
								+ '<h2 class="chatBoxType-tit">' + data["title"] + '</h2>'
								+ '<section class="chatBoxType-cont">'
								+ '^iconImg^'
								+ '<p>' + desc + '</p>'
								+ '</section>'
								+ '</a></article>';
							var defaultIconImg = own.path + 'images/defaultIcon/' + defaultIconMap["default"];
							var iconObj = defaultIconMap[data["type"]];
							if (iconObj) {
								defaultIconImg = own.path + 'images/defaultIcon/' + iconObj;
							}
							var iconImg = data["pic"] || defaultIconImg;
							var iconImgHtml = '<img src="' + iconImg + '" alt="" onerror="javascript:this.src=\'' + defaultIconImg + '\'">';
							html = html.replace(/\^iconImg\^/, iconImgHtml);
							return modelObj(own, msg, html, 'basic');
						},
						//表情信息
						"4": function () {
							var html = '<div class="ImgM"><img class="emoji" src="' + own.path + 'images/sticker/' + data.catalog + '/' + data.chartlet + '.gif' + '" /></div>';
							return modelObj(own, msg, html, 'basic');
						},
						//打赏信息,购买相关消息
						"2": function () {
							//data["type"]==29//购买消息
							//加入社群的消息，与通知重复。暂不处理
							var link = data["link"] || own.struct.host + '/zhangmen/card/info/detail-share-' + data["id"];
							
							if (data["type"] == 12) {
								return "";
							} else if (data["type"] == 28 && data["title"].indexOf('打赏了') != -1) {  //打赏
								data["title"] = data["title"].replace("群主", "");
								var html = '<div class="newChatDS clearfix">' + data["title"].split('打赏了')[0] + '打赏了<span>' + data["title"].split('打赏了')[1] + '</span></div>';
								return html;
							} else if (data["type"] == 33) {  //会员
								var html = '<div class="vipChatCon clearfix">'
									+ groupLink(link) + '<h3 class="tit">' + data["title"].split('购买了会员')[0] + '</h3>开通了会员，获得专属特权</a>'
									+ '<div class="desc"><p>会员免费观看</p><p>3倍流畅度</p><p>更多特权</p></div>'
									+ '</div>';
								return html;
							} else if (data["type"] == 29 && data["desc"].indexOf('￥') != -1) {
								var text = groupLink(link) + '<div class="cont"><div class="shopChatCon clearfix"><h3 class="tit">' + data["title"] + '</h3>' + '<div class="shopDesc"><img src="' + data["pic"] + '" class="pic">'
									+ '<div><p class="desc">' + data["desc"].split(',')[1] + '</p>'
									+ '<span class="link">' + data["desc"].split(',')[0] + '</span></div></div></div></div></a>';
								return modelObj(own, msg, text, 'basic');
							} else {
								var html = groupLink(link) + '<div class="chatJoin clearfix">'
									+ '<img src="' + data["pic"] + '" class="pic">'
									+ '<h3 class="tit">' + data["title"] + '</h3>'
									+ '<span class="link">' + data["desc"] + '</span>'
									+ '<p class="chat-arrow"></p>'
									+ '</div></a>';
								return html;
							}
						},
						//禁言与取消禁言
						"3": function () {
							var type = data["type"];
							if (type) {
								//var key=own.struct.account+"_"+own.struct.groupId;
								if (type == 22) {
									return '<div class="chatprompt">' + data["content"] + '</div>'
								}
								if (type == 6) {
									return '<div class="chatprompt">' + data["content"] + '</div>'
								}
							}
						},
						//群通知；
						"1301": function () {
							if (own.struct.groupNotice) {
								own.struct.groupNotice(msg, data);
							}
						},
						//群打卡信息
						"8": function () {
							var linkUrl = groupLink("/spa/daka/poster/" + data["id"]);
							var html='<article class="cardCont" style="background-image:url('+data["pic"]+')">'+linkUrl+'<div class="title">' + data["title"] + '</div><div class="content">' + data["content"] + '</div></a></article>'
							return modelObj(own, msg, html, 'basic');
						}
					}
					var typeFun = typeFunObj[content_.type];
					if (typeFun) {
						return typeFun();
					}
					return nonsupport();
					/*debugger;
					return "--------------------------------"+content_.type;*/
				};
				//通知类消息
				var notificationType = function (attach_) {
					var user = attach_["users"][0];
					var account = (attach_["accounts"] && attach_["accounts"].length) ? attach_["accounts"][0] : user;
					var typeFunObj = {
						//加入社群消息
						"addTeamMembers": function () {
							if (isNewMsg && account == own.struct.account) {
								if (own.struct.addedMember) {
									own.struct.addedMember(attach_);
								}
							}
							var linkUrl = own.struct.host + '/zhangmen/card/info/detail-share-' + user["account"];
							//var headImgUrl=methods.checkHeadImg(user.avatar,own.path+"images/defaultIcon/default_chat_ren.png");
							// var defaultUrl=own.path+"images/defaultIcon/default_chat_ren.png";
							// var headImgObj='<img src="'+user.avatar+'" class="pic" onerror="javascript:this.src=\''+defaultUrl+'\'">';


							var link = '<a href="' + linkUrl + '">';
							if (!gyAPI.isMobile()) {
								link = '<a href=javascript:window.open("' + linkUrl + '","","width=375,height=667")>';
							}
							var html = link + '<div class="newChatJoin clearfix"><h3 class="tit">';
							html += (user.fromNick || user.nick) + '</a>&nbsp;&nbsp;加入了群聊</h3>';
							//+'<span class="link">点击查看名片详情</span>'
							// +'<p class="chat-arrow"></p>'
							+'</div>';
							return html;
						},
						//更新社群信息
						"updateTeam": function () {
							/*console.log("-------updateTeam");
							console.log(attach_);
							/*debugger;*/
							/**暂不处理**/
							return "";
						},
						//退出社群信息
						"removeTeamMembers": function () {
							//alert("用于一个线上测试：请不要account:"+account+"----own.struct.account:"+own.struct.account+"-isNewMsg:"+isNewMsg);
							if (isNewMsg && account == own.struct.account) {
								if (own.struct.removedMember) {
									own.struct.removedMember(attach_);
								}
							}
							/*var url=own.struct.host+'/zhangmen/card/info/detail-share-'+user["account"];
							var html='<a href="'+url+'"><div class="chatJoin clearfix">'
					            +'<img src="'+user.avatar+'" class="pic">'
					            +'<h3 class="tit">'+user.nick+'&nbsp;&nbsp;移除社群</h3>'
					            +'<span class="link">点击查看名片详情</span>'
					            +'<p class="chat-arrow"></p>'
					          +'</div></a>';
					        return html;*/
							/*									console.log("-------removeTeamMembers");
														console.log(attach_);
														var info=attach_["users"][0].nick;
														return '<div class="chatDate">'+info+'撤回了一条消息</div>';*/
							/**暂不处理**/
							return ""
						}

					}
					var typeFun = typeFunObj[attach_.type];
					if (typeFun) {
						return typeFun();
					}
					return nonsupport();

				};
				var modelObj = function (own, msg, subText, type) {
					var models = {
						//基本格式
						basic: function () {//基本类型
							var flowClass = "";
							//var flowUserInfo='<h3 class="tit"><span>^userName^</span><em class="chatBoxItemIcon">掌门部总主管</em> </h3>';
							var flowUserInfo = '<h3 class="tit"><span>^userName^</span></h3>';
							var sendClass = '';
							if (msg.flow === "out") {
								flowClass = "chatBoxItemMy";
								flowUserInfo = "";
							}

							if (msg.status == "fail") {
								sendClass = 'sendFailIcon';
							}
							if (msg.status == "sending") {
								sendClass = "sendingIcon"
							}
							var errorInfo = ' errorInfo="' + msg.text + '" ';
							var msgHtml = '<dl class="chatBoxItem ' + flowClass + '">'
								+ '<dt class="pic">^headImg^</dt>'
								+ '<dd class="bd"><div class="' + sendClass + '" id="' + key + '" ' + errorInfo + '></div>' + flowUserInfo + '^msg^'
								+ '</dd></dl>';
							return msgHtml.replace(/\^msg\^/g, subText)
						},
						//居中格式。暂不支持;
						center: function () {//中间类型

						}
					}
					return models[type]();
				};
				var nonsupport = function () {
					var version = 'rc';
					var downUrl = own.struct.host + "/zhangmen/download/app-download?preview=" + version + "&version=" + version;
					var link = '<a href="' + downUrl + '">';
					if (!gyAPI.isMobile()) {
						link = '<a href="' + downUrl + '" target="_blank">';
					}
					var text = '<article class="chat-point">网页端暂不支持该条聊天格式，请' + link + '下载掌门APP</a>查看</article>'
					return text;
				};
				var buildEmoji = function (own, msg) {
					function IsURL(str_url) {
						var reg = /(http|ftp|https):\/\/[\w\-_]+(\.[\w\-_]+)+([\w\-\.,@?^=%&:/~\+#]*[\w\-\@?^=%&/~\+#])?/;
						return reg.test(str_url);
					};
					var typeAdpat = {
						//其本文本格式
						"text": function () {
							var text = msg.text;
							if (IsURL(text)) {//处理url类型
								text = '<div class="cont"><a href="' + text + '" target="_blank">' + text + '</a></div>';
								return modelObj(own, msg, text, 'basic');
							}
							var re = /\[([^\]\[]*)\]/g;
							var matches = text.match(re) || [];
							for (var j = 0, len = matches.length; j < len; ++j) {
								if (own.emoji[matches[j]]) {
									text = text.replace(matches[j], '<img class="emoji" src="' + own.path + 'images/face/emoji/' + own.emoji[matches[j]].file + '" />');
								}
							}
							var sendFailDiv = '';
							text = text.replace(/\r\n/g, "<br>")
							text = text.replace(/\n/g, "<br>");
							text = sendFailDiv + '<div class="cont">' + text + '</div>';
							return modelObj(own, msg, text, 'basic');
						},
						//自定义格式
						"custom": function () {
							if (msg.status === "success" && msg.content) {
								var content = JSON.parse(msg.content);
								return customType(content);
							}
						},
						//充图像
						"image": function () {
							var url = msg["file"].url;
							var text = '<div class="cont ImgM" ><img class="imgMsg" src="' + url + '" imgIndex="' + own.imgList.length + '"/></div>';
							own.imgList.push(url);
							return modelObj(own, msg, text, 'basic');
						},
						//音频
						"audio": function () {
							var url = msg.file.mp3Url;
							var dur = Math.round(msg.file.dur / 1000);
							var text = '<div class="cont" onClick="playChatAudio(this,\'' + url + '\');"><div class="chatYuyinPause">' + dur + '\"</div></div>';
							return modelObj(own, msg, text, 'basic');
						},
						//群通知。
						"notification": function () {
							if (msg.status === "success" && msg.attach) {
								return notificationType(msg.attach);
							}
							return "";
						}
					};
					var typeFun = typeAdpat[msg.type];
					if (typeFun) {
						return typeFun();
					} else {
						var text = nonsupport();
						return modelObj(own, msg, text, 'basic');
					};

				};
				/**
				*前置时间的计算，并显示
				**/
				var timeBefore = function (own, msg, html) {
					//debugger;
					var updateTime = msg.time;
					var nowDate = new Date();
					var nowTime = (nowDate).getTime();
					var now_00_time = new Date(nowDate.getFullYear(), nowDate.getMonth(), nowDate.getDate()).getTime();//小于今天的时间
					var betweenTime = nowTime - updateTime;//当前时间与消息的时间差
					var timeSplit = own.timeSplit * 60000;//间隔时间
					var timeHtml = '<time class="chatDate">^time^</time>';
					var timeFun = function () {
						if ((betweenTime > timeSplit) && ((updateTime - own.preTime) > timeSplit)) {//如果消息时间大于（当前时间+间隔时间）
							own.preTime = updateTime;
							if (updateTime < now_00_time) {
								return gyAPI.dateFormat(new Date(updateTime), "yyyy-MM-dd hh:mm");
							} else {
								//当前消息时间-上一条时间是否大于间隔，大于展示，不大于则不展示
								return gyAPI.dateFormat(new Date(updateTime), "hh:mm");
							}
						}
						return "";
					}
					if (betweenTime > timeSplit) {
						return timeHtml.replace(/\^time\^/g, timeFun()) + html;
					}
					return html;
				};
				if (msg.to == own.struct.account || msg.to == own.struct.groupId) {
					var htmlStr = buildEmoji(own, msg);
					if (htmlStr) {
						htmlStr = timeBefore(own, msg, htmlStr);
						methods.getUser(msg.from, function (userInfo) {
							var avatar = userInfo.avatar;
							var defautlHeadImg = own.path + "images/defaultIcon/default_chat_ren.png";
							//userInfo["avatar"]=avatar;
							htmlStr = htmlStr.replace(/\^userName\^/g, (msg.fromNick || userInfo.fromNick || userInfo.nick))
							//头像信息
							var headImgHtml = '<img src="' + avatar + '" onerror="javascript:this.src=\'' + defautlHeadImg + '\'">'
							htmlStr = htmlStr.replace(/\^headImg\^/g, headImgHtml);
							//回调绘制样式的方法;
							var fun = callFunMsg || own.struct.drewHtmlMsg;
							if (fun) {
								fun(htmlStr, msg, isNewMsg);
							}
						})
					}
				}
			},
			getUser: function (accountId, fun) {
				var groupUser = function (user) {
					own.userMap[accountId] = user;
					fun(user);
				};
				if (own.userMap[accountId]) {
					fun(own.userMap[accountId]);
				} else {
					if (own.struct.getUserInfo) {//如果调用方提供获取用户信息方法。则直接调用
						own.struct.getUserInfo(accountId, function (user) {
							groupUser(user);
						});
					} else {//默认调用群聊获取用户信息。
						own.nim.getUser({
							account: accountId,
							done: function (error, user) {
								if (!error) {
									groupUser(user);
								}
							}
						});
					}
				}
			},
			onError: function (error) {
				console.log(error);
			}
		}

		own.methods = methods;
		setTimeout(function () {
			var obj = {
				//debug: true,
				syncFriends: false,//不同步好友信息
				appKey: own.struct.appKey,
				account: own.struct.account,
				token: own.struct.token,
				onmyinfo: own.struct.onUsers,
				onconnect: methods.onConnect,
				onwillreconnect: methods.onWillReconnect,
				ondisconnect: methods.onDisconnect,
				onsyncdone: methods.onSyncDone,
				onfriends: methods.onFriends,
				onsessions: methods.onSessions,
				onupdatesession: methods.onUpdateSession,

				//onofflinemsgs: methods.onOfflineMsgs,
				onmsg: methods.onMsg,
				onerror: methods.onError,
				oncustomsysmsg: methods.onCustomsysmsg,
				syncRoamingMsgs: own.struct.isSyncRoamingMsgs,
				isRoamingable: false,//暂不支持漫游消息
				onroamingmsgs: methods.onRoamingMsgs
			}
			own.nim = NIM.getInstance(obj);
		}, 1000);

	}

}


module.exports = Chat;
